[![PyPI](https://img.shields.io/pypi/v/pythle)](https://pypi.org/project/pythle/)
[![GitHub Workflow Status (branch)](https://img.shields.io/github/workflow/status/TomJGooding/pythle/Python%20application/main)](https://github.com/TomJGooding/pythle/actions/workflows/python-app.yml?query=branch%3Amain)
[![GitHub Workflow Status (branch)](https://img.shields.io/github/workflow/status/TomJGooding/pythle/pytester-cov/main?label=coverage)](https://github.com/TomJGooding/pythle/actions/workflows/pytester-cov.yml?query=branch%3Amain)
[![GitHub issues by-label](https://img.shields.io/github/issues/TomJGooding/pythle/bug?label=bug%20reports)](https://github.com/TomJGooding/pythle/labels/bug)
[![GitHub issues by-label](https://img.shields.io/github/issues/TomJGooding/pythle/enhancement?label=feature%20requests)](https://github.com/TomJGooding/pythle/labels/enhancement)

# Pythle

A terminal-based version of the popular word-guessing game Wordle, built with Python.

Created as my first GitHub project!

![pythle-screenshot](assets/images/pythle-screenshot.png)

## Table of Contents

- [Getting Started](#getting-started)
  - [Prerequisites](#prerequisites)
  - [Installation](#installation)
- [Play](#play)
- [Contributing](#contributing)
- [Acknowledgements](#acknowledgements)
- [Licence](#licence)

## Getting Started

### Prerequisites

**A terminal with support for [ANSI colours](https://en.wikipedia.org/wiki/ANSI_escape_code#Colors) is required.**

Before you go any further, [ensure you have Python and that the expected version is available from your command line](https://packaging.python.org/en/latest/tutorials/installing-packages/#ensure-you-can-run-python-from-the-command-line).

If you do not have Python, please install the latest 3.x version from [python.org](https://www.python.org/) or refer to the [Installing Python](https://docs.python-guide.org/starting/installation/#installation) section of the Hitchhiker’s Guide to Python.

### Installation

To learn how to install a Python file (package), refer to the [Installation Tutorial](https://packaging.python.org/en/latest/tutorials/installing-packages/) from PyPI.

Install using pip:

```
pip install pythle
```

## Play

To start the game, run from the command line:

```
pythle
```

Type your guess and hit the enter button to submit.

## Contributing

Thank you for your interest in contributing to this project!

Contributions are what make the open source community such an amazing place to learn, inspire, and create. Any contributions you make are **greatly appreciated**.

There are many ways in which you can participate in this project, including some that don't require you to write a single line of code:

- Report a bug
- Request a feature/enhancement
- Write documentation, for users and contributors
- Contribute to the codebase

If you're looking for a way to contribute, you can scan through the existing issues for something to work on.

Please take a moment to read the [Contribution Guidelines](CONTRIBUTING.md), to help make the process easy and effective for everyone involved.

## Acknowledgements

<!---
If you used any third-party assets that require attribution, list the creators with links to their primary web presence in this section.

If you followed tutorials, include links to those here as well.
-->

- [Wordle](https://www.nytimes.com/games/wordle/index.html) by [Josh Wardle](https://www.powerlanguage.co.uk/)
- [Al Sweigart](https://inventwithpython.com/) for his excellent series of books on learning Python, available for free!
- [ArjanCodes](https://www.youtube.com/channel/UCVhQ2NnY5Rskt6UjCUkJ_DA) and his [Code Roast YouTube videos](https://www.youtube.com/playlist?list=PLC0nd42SBTaNVxWLci4TPoytfzkXxFhCg) for inspiring me to try to write better code.
- [Programming with Alex](https://www.youtube.com/channel/UCTebDgj-GzOh3zo9Xf1vO4A/) for his [pytester-cov](https://github.com/marketplace/actions/pytester-cov) GitHub Action used to check code coverage in this project.

## Licence

Licensed under the [GNU General Public License v3.0](LICENSE).
